import javax.swing.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;

public class DynaGUI extends CloseableJFrame implements ActionListener
	{

	public static final String ADDTask = "Add a Task";
        JScrollPane scroll;
        static DynaGUI frame;
        static JPanel panelMain;
	JPanel panelDynamic;
	JPanel panelStatic;
        static Vector vecTasks;     // the grid of Tasks
        JButton buttonAddTask;
        static TaskManager TM;

	public DynaGUI(TaskManager tm)
		{
                super("TimeSlice");
                TM = tm;
                Container cp = getContentPane();
		cp.setLayout(new GridLayout());
		// Create a Vector to keep track of buttons within the grid
		vecTasks = new Vector();




                panelMain = new JPanel();
		GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints gbc;
		panelMain.setLayout(gbl);
		// Add-Button
		gbc = makegbc(0,0,1,1);
		gbc.fill = GridBagConstraints.NONE;
		gbc.anchor = GridBagConstraints.WEST;
		JButton buttonAddTask = new JButton(ADDTask);
                buttonAddTask.addActionListener(this);
                gbl.setConstraints(buttonAddTask,gbc);
		panelMain.add(buttonAddTask);
		//DeactivateButton
		gbc = makegbc(1,0,1,1);
		gbc.fill = GridBagConstraints.NONE;
		gbc.anchor = GridBagConstraints.EAST;
		JButton buttonDeactivateTasks = new JButton("Deactivate");
		buttonDeactivateTasks.addActionListener(this);
                gbl.setConstraints(buttonDeactivateTasks,gbc);
		panelMain.add(buttonDeactivateTasks);
		//panelDynamic einfuegen
                gbc = makegbc(0,1,3,2);
		gbc.weightx = 100;
		gbc.weighty = 100;
		gbc.fill = GridBagConstraints.BOTH;
                panelDynamic = new JPanel();
                panelDynamic.setLayout(new FlowLayout());
                scroll = new JScrollPane(panelDynamic);
                gbl.setConstraints(scroll,gbc);
		panelMain.add(scroll);

                cp.add(panelMain);
                }

 	private JPanel generateJPanel(int i)
		{
		JPanel tempPanel = new JPanel();
		GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints gbc;
		tempPanel.setLayout(gbl);
		// Loeschen-Button
		gbc = makegbc(0,0,1,1);
		gbc.fill = GridBagConstraints.NONE;
		gbc.anchor = GridBagConstraints.EAST;
		JButton tempDeleteB = new JButton("Loesche Task "+i);
                tempDeleteB.addActionListener(this);
                gbl.setConstraints(tempDeleteB,gbc);
		tempPanel.add(tempDeleteB);
		//AktivierenButton
		gbc = makegbc(1,0,1,1);
		gbc.fill = GridBagConstraints.NONE;
		gbc.anchor = GridBagConstraints.EAST;
		JButton tempActivateB = new JButton("Aktiviere Task "+i);
		tempActivateB.addActionListener(this);
                gbl.setConstraints(tempActivateB,gbc);
		tempPanel.add(tempActivateB);
		//EditierenButton
		gbc = makegbc(2,0,1,1);
		gbc.fill = GridBagConstraints.NONE;
		gbc.anchor = GridBagConstraints.EAST;
		JButton tempEditB = new JButton("Editiere Task "+i);
		tempEditB.addActionListener(this);
                gbl.setConstraints(tempEditB,gbc);
		tempPanel.add(tempEditB);
                //JTextArea einfuegen
                gbc = makegbc(0,1,3,1);
		gbc.weightx = 100;
		gbc.weighty = 100;
		gbc.fill = GridBagConstraints.BOTH;
		JTextArea text = new JTextArea("",4,1);
                gbl.setConstraints(text,gbc);
		tempPanel.add(text);
		return tempPanel;
		}
		private GridBagConstraints makegbc(int x, int y, int width, int height)
			{
			GridBagConstraints gbc =  new GridBagConstraints();
			gbc.gridx = x;
			gbc.gridy = y;
			gbc.gridwidth = width;
			gbc.gridheight = height;
			gbc.insets = new Insets(2,2,2,2);
			return gbc;
			}

        //Diese Methode ermittelt die ID des zu lschenden Panels in der Vektor-Liste
        //anhand des Button-Namens
        private int getID(String name)
                {
                int i = 0;
                JPanel temp;
                JButton tempB = new JButton();
                for (i = 0 ; i < vecTasks.size() ; i++)
                        {
                        temp = (JPanel)vecTasks.elementAt(i);
                        tempB = (JButton)temp.getComponent(1);
                        if (tempB.getText().equals(name))
                                {
                                break;
                                }
                        }
                return i;
                }


	public void actionPerformed(ActionEvent event)
		{
		String command = event.getActionCommand();
                if (command.compareTo(ADDTask) == 0)
			{
			// Create new button and add to panelDynamic -- see makeButtonGrid()
			int i = vecTasks.size() + 1;
                        JPanel tmp = generateJPanel(i);
                        panelDynamic.add(tmp);
                        vecTasks.addElement(tmp);
                        TM.add();
                        panelMain.validate();
                        }
                if (command.startsWith("Editiere Task"))
                        {
                        String Nummer_vom_Task = new String(command.substring(14));
                        int taskNummer = Integer.valueOf(Nummer_vom_Task).intValue();

                        String tempName = (String)JOptionPane.showInputDialog(panelMain,"Bitte geben Sie den Namen ein");
                        String tempZeit = (String)JOptionPane.showInputDialog(panelMain,"Bitte geben Sie ein, wie lange Sie pro Zeitperiode an diesem Task arbeiten mchten (in Minuten)");
                        String tempPeriode = (String)JOptionPane.showInputDialog(panelMain,"Bitte geben Sie die Periodendauer (in Minuten) ein");
                        long inttempZeit = Long.valueOf(tempZeit).longValue();
                        long inttempPeriode = Long.valueOf(tempPeriode).longValue();
                        TM.edit(taskNummer, tempName, inttempZeit, inttempPeriode);
                        setData();
                        }
                if (command.startsWith("Aktiviere Task"))
                        {
                        String Nummer_vom_Task = new String(command.substring(15));
                        int taskNummer = Integer.valueOf(Nummer_vom_Task).intValue();
                        TM.activate(taskNummer-1);
                        setData();
                        }
                if (command.equals("Deactivate"))
                        {
                        boolean temp = TM.deactivateAll();
                        }

                if (command.startsWith("Loesche Task"))
                        {
                        String Nummer_vom_Task = new String(command.substring(13));
                        int taskNummer = Integer.valueOf(Nummer_vom_Task).intValue();
                        TM.delete(taskNummer);
                        JPanel temp = (JPanel)(vecTasks.remove(getID(command)-1));
                        panelDynamic.remove(temp);
                        panelDynamic.revalidate();
                        repaint();
                        }


                }

        public static void setData()
                {
                String[] e = TM.refresh();
                JPanel temp;
                JTextArea tempText;

                for (int i = 0 ; i < vecTasks.size(); i++)
                        {
                        temp = (JPanel)vecTasks.elementAt(i);
                        tempText = (JTextArea)temp.getComponent(3);
                        tempText.selectAll();
                        tempText.cut();
                        tempText.append(e[i]);
                        }
                panelMain.revalidate();
                }

    }
